/* Interface fuer Flex-Routinen in C-Umgebung */

#include "flex.h"
#include "fx_c.h"

extern void qksort();

FLEX *
FXS_dup( fx )
FLEX *fx;
{
	FLEX  *fz;

	if (fx)
	{
	   fz = flex( fx->fxdim, fx->fxisz, fx->fxext );

	   if ( fz != NULL )
	   {
		copy(fz->fxdata,fx->fxdata,fx->fxisz*fx->fxused);
		fz->fxused = fx->fxused;
	   }

	   return ( fz );
	}
	else
	   return ( NULL );
}

FLEX *
FXS_clr( fx )			/* Alle Elemente loeschen */
FLEX *fx;
{
	if (fx)
	{
	   fx->fxused = 0;
	   return ( fx );
	}

	return ( NULL );
}


FLEX *
FXS_srt( fx, qvgl )
FLEX *fx;
int  (* qvgl)();
{
	char	*it;

	if (fx)
	{
	   qksort( fx->fxdata, fx->fxused, (int) fx->fxisz, qvgl );
	   return ( fx );
	}

	return ( NULL );
}

FLEX *
FXS_ssh( fx, sort, vgl )
FLEX *fx;
void	(* sort)();
short	(*  vgl)();
{
	char	*it;
	unsigned nel;

	if (fx)
	{
	   nel = fx->fxused;
	   sort( fx->fxdata, nel, vgl );
	   return ( fx );
	}

	return ( NULL );
}

FLEX *
FXA_ele( fx, n, itm )
FLEX *fx;
unsigned n;
char	*itm;
{
	char	*it;

	if (fx)
	{
	   it = fxitem( fx, n );

	   if ( it )
	   {
	      copy( itm, it, fx->fxisz );
	      return ( fx );
	   }
	}

	return ( NULL );
}

unsigned int
FXA_nel( fx )
FLEX *fx;
{
	if (fx)
	   return ( fx->fxused );

	return ( 0 );
}

#ifndef vms
copy( p, q, n )
char *p, *q;
int  n;
{
	for ( ; n > 0; --n )
		*p++ = *q++;
}
#endif
